package immibis.ars;

import immibis.core.api.porting.SidedProxy;
import java.util.ArrayList;
import net.minecraft.server.Item;
import net.minecraft.server.ItemStack;

public class ItemComponent extends Item
{
    public static final int META_ENERGY_MODULATOR = 0;
    public static final int META_DIAMOND_LENS = 1;
    public static final int META_PROJECTOR_BASE = 2;
    private String[] internal_names;

    public ItemComponent(int var1)
    {
        super(var1);
        String[] var2 = new String[] {"Energy modulator", "Diamond lens", "Forcefield projector base"};
        this.setMaxDurability(0);
        this.a(true);
        this.internal_names = new String[var2.length];

        for (int var3 = 0; var3 < var2.length && var3 < 16; ++var3)
        {
            this.internal_names[var3] = "ARS-component." + var3;
            SidedProxy.instance.addLocalization(this.internal_names[var3] + ".name", var2[var3]);
        }

        this.setTextureFile("/immibis/ars/textures/items.png");
    }

    public String a(ItemStack var1)
    {
        try
        {
            return this.internal_names[var1.getData()];
        }
        catch (ArrayIndexOutOfBoundsException var2)
        {
            return "";
        }
    }

    public void addCreativeItems(ArrayList var1)
    {
        for (int var2 = 0; var2 < 3; ++var2)
        {
            var1.add(new ItemStack(this, 1, var2));
        }
    }
}
