package immibis.ars;

import net.minecraft.server.ItemStack;
import net.minecraft.server.NBTTagCompound;
import net.minecraft.server.NetworkManager;
import net.minecraft.server.Packet;
import net.minecraft.server.Packet132TileEntityData;
import net.minecraft.server.TileEntity;

public class TileUpgradePassive extends TileEntityMaschines
{
    private short connectet_typID = 0;
    private int conectet_ID = 0;
    private int counter = 0;

    /**
     * Overriden in a sign to provide the text
     */
    public Packet d()
    {
        Packet132TileEntityData var1 = new Packet132TileEntityData();
        var1.lowPriority = true;
        var1.a = this.x;
        var1.b = this.y;
        var1.c = this.z;
        var1.d = (this.conectet_ID != 0 ? 1 : 0) | (this.getActive() ? 2 : 0) | this.getFacing() << 2;
        return var1;
    }

    public void onDataPacket(NetworkManager var1, Packet132TileEntityData var2)
    {
        this.setconectet_ID(var2.d & 1);
        this.setActive((var2.d & 2) != 0);
        this.setFacing((short)(var2.d >> 2));
    }

    public int getconectet_ID()
    {
        return this.conectet_ID;
    }

    public void setconectet_ID(int var1)
    {
        this.conectet_ID = var1;

        if (this.conectet_ID != 0 != (var1 != 0))
        {
            this.world.notify(this.x, this.y, this.z);
        }
    }

    public short getConnectet_typID()
    {
        return this.connectet_typID;
    }

    public void setConnectet_typID(short var1)
    {
        this.connectet_typID = var1;
    }

    /**
     * Allows the entity to update its state. Overridden in most subclasses, e.g. the mob spawner uses this to count
     * ticks and creates a new spawn inside its implementation.
     */
    public void q_()
    {
        if (!this.world.isStatic)
        {
            if (this.getActive() && this.getWrenchDropRate() != -1.0F)
            {
                this.setWrenchRate(-1.0F);
            }

            if (!this.getActive() && this.getWrenchDropRate() != 1.0F)
            {
                this.setWrenchRate(1.0F);
            }
        }
    }

    public void updatecheck()
    {
        if (!this.world.isStatic && this.conectet_ID != 0)
        {
            switch (this.connectet_typID)
            {
                case 1:
                    TileEntity var1 = (TileEntity)Linkgrid.getWorldMap(this.world).getGenerator().get(Integer.valueOf(this.conectet_ID));

                    if (var1 == null)
                    {
                        this.setconectet_ID(0);
                        this.setActive(false);
                        this.q_();
                    }

                    break;

                case 2:
                    TileEntity var2 = (TileEntity)Linkgrid.getWorldMap(this.world).getProjektor().get(Integer.valueOf(this.conectet_ID));

                    if (var2 == null)
                    {
                        this.setconectet_ID(0);
                        this.setActive(false);
                        this.q_();
                    }
            }
        }
    }

    /**
     * Reads a tile entity from NBT.
     */
    public void a(NBTTagCompound var1)
    {
        super.a(var1);
    }

    /**
     * Writes a tile entity to NBT.
     */
    public void b(NBTTagCompound var1)
    {
        super.b(var1);
    }
    
    @Override
    public ItemStack[] getContents() {return new ItemStack[0];}
}
