package immibis.ars.beams;

import immibis.core.BasicInventory;
import immibis.core.api.porting.PortableContainer;
import net.minecraft.server.EntityHuman;
import net.minecraft.server.ItemStack;
import net.minecraft.server.Slot;

public class ContainerLootCollector extends PortableContainer
{
    public ContainerLootCollector(EntityHuman var1, TileLootCollector var2)
    {
        super(var1, var2);
        int var3;

        for (var3 = 0; var3 < 9; ++var3)
        {
            this.a(new Slot(var1.inventory, var3, 8 + 18 * var3, 198));
        }

        int var4;

        for (var3 = 0; var3 < 3; ++var3)
        {
            for (var4 = 0; var4 < 9; ++var4)
            {
                this.a(new Slot(var1.inventory, var4 + var3 * 9 + 9, 8 + 18 * var4, 140 + 18 * var3));
            }
        }

        for (var3 = 0; var3 < 3; ++var3)
        {
            for (var4 = 0; var4 < 3; ++var4)
            {
                this.a(new Slot(var2, var3 + var4 * 3 + 1, 62 + var3 * 18, 75 + var4 * 18));
            }
        }

        this.a(new Slot(var2, 0, 80, 31));
    }

    /**
     * Called to transfer a stack from one inventory to the other eg. when shift clicking.
     */
    public ItemStack a(int var1)
    {
        if (var1 < 36)
        {
            if (this.inv.getItem(0) == null)
            {
                ItemStack var3 = this.player.inventory.getItem(var1);

                if (var3 == null)
                {
                    return null;
                }
                else
                {
                    --var3.count;

                    if (var3.count == 0)
                    {
                        this.player.inventory.setItem(var1, (ItemStack)null);
                    }
                    else
                    {
                        this.player.inventory.setItem(var1, var3);
                    }

                    var3 = var3.cloneItemStack();
                    var3.count = 1;
                    this.inv.setItem(0, var3);
                    return null;
                }
            }
            else
            {
                BasicInventory.mergeStackIntoRange(this.player.inventory, this.inv, var1, 1, 10);
                return null;
            }
        }
        else
        {
            Slot var2 = (Slot)this.e.get(var1);
            var2.set(BasicInventory.mergeStackIntoRange(var2.getItem(), this.player.inventory, 0, 36));
            return null;
        }
    }
}
