package immibis.ars.beams.logictypes;

import immibis.ars.beams.EntityFilter;
import immibis.ars.beams.LogicType;
import immibis.ars.beams.TileUpgradeUnit;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import net.minecraft.server.Entity;

public class ClassDetector extends LogicType
{
    public Class clazz;

    public ClassDetector(Class var1)
    {
        this.clazz = var1;
    }

    public EntityFilter createFilter(TileUpgradeUnit var1, EntityFilter[] var2)
    {
        return new EntityFilter()
        {
            public Set filter(Set var1)
            {
                HashSet var2 = new HashSet();
                Iterator var4 = var1.iterator();

                while (var4.hasNext())
                {
                    Entity var3 = (Entity)var4.next();

                    if (ClassDetector.this.clazz.isAssignableFrom(var3.getClass()))
                    {
                        var2.add(var3);
                    }
                }

                return var2;
            }
        };
    }
}
